! Denis GIROU (CNRS/IDRIS - France) <Denis.Girou@idris.fr> -  9 Oct. 1996

! Inversion de matrice avec IMSL F90 MP

program inversion_matrice_IMSL

  use linear_operators
  use lin_sol_gen_int
  use rand_gen_int

  implicit none
  integer, parameter :: n=500
  integer            :: i,options_for_lin_sol_lsq,s_use_lin_sol_lsq_only
  real(kind(1e0))    :: a1(n,n),a2(n,n),b(n,0),inv(n,n),x(n,0), &
                        temp(n*n),determinant(2),determinant_2, &
                        temps_debut,temps_fin,second
  type(s_options)    :: iopt(2)=s_options(0,1.e0)

!  allocate(s_rand_options(2))
!  s_rand_options(1)=options_for_rand_gen
!  s_rand_options(1)=s_options(s_rand_gen_generator_seed,0.)
!  a1(:,:)=rand(a1(:,:))

  iopt(1)=s_options(s_rand_gen_generator_seed,0.)
  call rand_gen(temp)
  a1(:,:)=reshape(temp,(/n,n/))
  a2(:,:)=a1(:,:)

  ! Calcul de la matrice inverse et du dterminant
  temps_debut=second()
  call lin_sol_gen(a1,b,x,nrhs=0,ainv=inv,det=determinant)
!  call lin_sol_gen(a1,b,x,nrhs=0,ainv=inv)
  temps_fin=second()
  print *,'Temps lin_sol_gen ',temps_fin-temps_debut
  print *,inv(1,1),inv(10,10),abs(determinant(1))**determinant(2)

  ! Calcul de la matrice inverse et du dterminant
  temps_debut=second()
  inv=.i.a2
  determinant_2=det(a2)
  temps_fin=second()
  print *,'Temps oprateurs  ',temps_fin-temps_debut
  print *,inv(1,1),inv(10,10),determinant_2

  ! Calcul de la matrice inverse et du dterminant
  allocate(s_inv_options(2))
  s_inv_options(1)=options_for_lin_sol_lsq
  s_inv_options(2)=s_use_lin_sol_lsq_only
  temps_debut=second()
  inv=.i.a2
  determinant_2=det(a2)
  temps_fin=second()
  print *,'Temps oprateurs  ',temps_fin-temps_debut
  print *,inv(1,1),inv(10,10),determinant_2

end program inversion_matrice_IMSL
